# Contributing to Spotty

**Thank you for your interest in Spotty. Your contributions are highly welcome.**

There are multiple ways of getting involved:

- [Report a bug](#report-a-bug)
- [Suggest a feature](#suggest-a-feature)
- [Contribute code](#contribute-code)

Below are a few guidelines we would like you to follow.
If you need help, please reach out to us by opening an issue.

## Report a bug 

Reporting bugs is one of the best ways to contribute. Before creating a bug report, 
please check that an [issue](https://github.com/spotty-cloud/spotty/issues) reporting the same problem does not already 
exist. If there is such an issue, you may add your information as a comment.

To report a new bug you should open an issue that summarizes the bug and set the label to "bug".

If you want to provide a fix along with your bug report: that is great! In this case please send us a pull request as 
described in section [Contribute Code](#contribute-code).

## Suggest a feature

To request a new feature you should open an [issue](https://github.com/spotty-cloud/spotty/issues/new) and summarize 
the desired functionality and its use case. Set the issue label to "feature".  

## Contribute code

This is a rough outline of what the workflow for code contributions looks like:
- Check the list of open [issues](https://github.com/spotty-cloud/spotty/issues). Either assign an existing issue to 
yourself or create a new one that you would like to work on and discuss your ideas and use cases. It is always best to 
discuss your plans beforehand, to ensure that your contribution is in line with our goals for Spotty.
- Fork the repository on GitHub
- Create a topic branch from where you want to base your work. This is usually the master.
- Make commits of logical units
- Write good commit messages (see below)
- Push your changes to a topic branch in your fork of the repository
- Submit a pull request to [spotty-cloud/spotty](https://github.com/spotty-cloud/spotty)

Thanks for your contributions!

### Commit messages

Your commit messages ideally can answer two questions: what changed and why. The subject line should feature 
the "what" and the body of the commit should describe the "why".

When creating a pull request, its comment should reference the corresponding issue ID.

**Have fun and enjoy hacking!**
